/// <reference types="frida-gum" />
/** */
declare class Il2CppBase {
    protected constructor();
    /** */
    static get applicationDataPath(): string;
    /** */
    static get applicationIdentifier(): string | null;
    /** Gets the version of the application */
    static get applicationVersion(): string | null;
    /** Gets the attached threads. */
    static get attachedThreads(): Il2Cpp.Thread[];
    /** Gets the current attached thread, if any. */
    static get currentThread(): Il2Cpp.Thread | null;
    /** Gets the Il2Cpp module as a Frida module. */
    static get module(): Module;
    /** Gets the Unity version of the current application. */
    static get unityVersion(): string;
    /** Allocates the given amount of bytes. */
    static alloc(size?: number | UInt64): NativePointer;
    /** Dumps the application. */
    static dump(fileName?: string, path?: string): void;
    /** Frees memory. */
    static free(pointer: NativePointerValue): void;
    /** */
    static installExceptionListener(targetThread?: "current" | "all"): InvocationListener;
    /** */
    static internalCall<R extends NativeFunctionReturnType, A extends NativeFunctionArgumentType[] | []>(name: string, retType: R, argTypes: A): NativeFunction<GetValue<NativeFunctionReturnTypeMap, NativeFunctionReturnValue, NativeFunctionReturnType, R>, ResolveVariadic<Extract<GetValue<NativeFunctionArgumentTypeMap, NativeFunctionArgumentValue, NativeFunctionArgumentType, A>, unknown[]>>> | null;
    /** Schedules a callback on the Il2Cpp initializer thread. */
    static scheduleOnInitializerThread<T>(block: () => T | Promise<T>): Promise<T>;
    /** Attaches the caller thread to Il2Cpp domain and executes the given block.  */
    static perform<T>(block: () => T | Promise<T>): Promise<T>;
    /** Creates a new `Il2Cpp.Tracer` instance. */
    static trace(): Pick<Il2Cpp.Tracer, "domain" | "assemblies" | "classes" | "methods">;
}
declare global {
    class Il2Cpp extends Il2CppBase {
    }
}
export {};
