import { NativeStruct } from "../../utils/native-struct";
/** Represents a `Il2CppArraySize`. */
declare class Il2CppArray<T extends Il2Cpp.Field.Type = Il2Cpp.Field.Type> extends NativeStruct implements Iterable<T> {
    /** Creates a new empty array of the given length. */
    static from<T extends Il2Cpp.Field.Type>(klass: Il2Cpp.Class, length: number): Il2Cpp.Array<T>;
    /** Creates a new array with the given elements. */
    static from<T extends Il2Cpp.Field.Type>(klass: Il2Cpp.Class, elements: T[]): Il2Cpp.Array<T>;
    /** Gets the size of the object encompassed by the current array. */
    get elementSize(): number;
    /** Gets the type of the object encompassed by the current array. */
    get elementType(): Il2Cpp.Type;
    /** Gets the total number of elements in all the dimensions of the current array. */
    get length(): number;
    /** Gets the encompassing object of the current array. */
    get object(): Il2Cpp.Object;
    /** Gets the element at the specified index of the current array. */
    get(index: number): T;
    /** Sets the element at the specified index of the current array. */
    set(index: number, value: T): void;
    /** */
    toString(): string;
    /** Iterable. */
    [Symbol.iterator](): IterableIterator<T>;
}
declare global {
    namespace Il2Cpp {
        class Array<T extends Il2Cpp.Field.Type = Il2Cpp.Field.Type> extends Il2CppArray<T> {
        }
    }
}
export {};
