/// <reference types="frida-gum" />
import { NonNullNativeStruct } from "../../utils/native-struct";
/** Represents a `FieldInfo`. */
declare class Il2CppField<T extends Il2Cpp.Field.Type> extends NonNullNativeStruct {
    /** Gets the class in which this field is defined. */
    get class(): Il2Cpp.Class;
    /** Gets the flags of the current field. */
    get flags(): number;
    /** Determines whether this field value is known at compile time. */
    get isLiteral(): boolean;
    /** Determines whether this field is static. */
    get isStatic(): boolean;
    /** Determines whether this field is thread static. */
    get isThreadStatic(): boolean;
    /** Gets the access modifier of this field. */
    get modifier(): string;
    /** Gets the name of this field. */
    get name(): string;
    /** Gets the offset of this field, calculated as the difference with its owner virtual address. */
    get offset(): number;
    /** Gets the type of this field. */
    get type(): Il2Cpp.Type;
    /** Gets the value of this field. */
    get value(): T;
    /** Sets the value of this field. Thread static or literal values cannot be altered yet. */
    set value(value: T);
    /** */
    toString(): string;
}
declare global {
    namespace Il2Cpp {
        class Field<T extends Il2Cpp.Field.Type = Il2Cpp.Field.Type> extends Il2CppField<T> {
        }
        namespace Field {
            type Type = boolean | number | Int64 | UInt64 | NativePointer | Il2Cpp.Pointer | Il2Cpp.ValueType | Il2Cpp.Object | Il2Cpp.String | Il2Cpp.Array;
            const enum Attributes {
                FieldAccessMask = 7,
                PrivateScope = 0,
                Private = 1,
                FamilyAndAssembly = 2,
                Assembly = 3,
                Family = 4,
                FamilyOrAssembly = 5,
                Public = 6,
                Static = 16,
                InitOnly = 32,
                Literal = 64,
                NotSerialized = 128,
                SpecialName = 512,
                PinvokeImpl = 8192,
                ReservedMask = 38144,
                RTSpecialName = 1024,
                HasFieldMarshal = 4096,
                HasDefault = 32768,
                HasFieldRVA = 256
            }
        }
    }
}
export {};
