/// <reference types="frida-gum" />
import { NonNullNativeStruct } from "../../utils/native-struct";
/** Represents a `Il2CppManagedMemorySnapshot`. */
declare class Il2CppMemorySnapshot extends NonNullNativeStruct {
    /** Captures a memory snapshot. */
    static capture(): Il2Cpp.MemorySnapshot;
    /** Creates a memory snapshot with the given handle. */
    constructor(handle?: NativePointer);
    /** Gets any initialized class. */
    get classes(): Il2Cpp.Class[];
    /** Gets the objects tracked by this memory snapshot. */
    get objects(): Il2Cpp.Object[];
    /** Frees this memory snapshot. */
    free(): void;
}
declare global {
    namespace Il2Cpp {
        class MemorySnapshot extends Il2CppMemorySnapshot {
        }
    }
}
export {};
