import { NativeStruct } from "../../utils/native-struct";
/** Represents a `Il2CppObject`. */
declare class Il2CppObject extends NativeStruct {
    /** Gets the class of this object. */
    get class(): Il2Cpp.Class;
    /** Gets the size of the current object. */
    get size(): number;
    /** Acquires an exclusive lock on the current object. */
    enter(): void;
    /** Release an exclusive lock on the current object. */
    exit(): void;
    /** Gets the field with the given name. */
    field<T extends Il2Cpp.Field.Type>(name: string): Il2Cpp.Field<T>;
    /** Gets the method with the given name. */
    method<T extends Il2Cpp.Method.ReturnType>(name: string, parameterCount?: number): Il2Cpp.Method<T>;
    /** Notifies a thread in the waiting queue of a change in the locked object's state. */
    pulse(): void;
    /** Notifies all waiting threads of a change in the object's state. */
    pulseAll(): void;
    /** Creates a reference to this object. */
    ref(pin: boolean): Il2Cpp.GC.Handle;
    /** Gets the correct virtual method from the given virtual method. */
    virtualMethod<T extends Il2Cpp.Method.ReturnType>(method: Il2Cpp.Method): Il2Cpp.Method<T>;
    /** Attempts to acquire an exclusive lock on the current object. */
    tryEnter(timeout: number): boolean;
    /** Gets the field with the given name. */
    tryField<T extends Il2Cpp.Field.Type>(name: string): Il2Cpp.Field<T> | undefined;
    /** Gets the field with the given name. */
    tryMethod<T extends Il2Cpp.Method.ReturnType>(name: string, parameterCount?: number): Il2Cpp.Method<T> | undefined;
    /** Releases the lock on an object and attempts to block the current thread until it reacquires the lock. */
    tryWait(timeout: number): boolean;
    /** */
    toString(): string;
    /** Unboxes the value type out of this object. */
    unbox(): Il2Cpp.ValueType;
    /** Releases the lock on an object and blocks the current thread until it reacquires the lock. */
    wait(): void;
    /** Creates a weak reference to this object. */
    weakRef(trackResurrection: boolean): Il2Cpp.GC.Handle;
}
declare global {
    namespace Il2Cpp {
        class Object extends Il2CppObject {
        }
    }
}
export {};
