/// <reference types="frida-gum" />
import { NativeStruct } from "../../utils/native-struct";
/** */
declare class Il2CppPointer<T extends Il2Cpp.Field.Type> extends NativeStruct {
    readonly type: Il2Cpp.Type;
    constructor(handle: NativePointer, type: Il2Cpp.Type);
    /** Gets the element at the given index. */
    get(index: number): T;
    /** Reads the given amount of elements starting at the given offset. */
    read(length: number, offset?: number): T[];
    /** Sets the given element at the given index */
    set(index: number, value: T): void;
    /** */
    toString(): string;
    /** Writes the given elements starting at the given index. */
    write(values: T[], offset?: number): void;
}
declare global {
    namespace Il2Cpp {
        class Pointer<T extends Il2Cpp.Field.Type = Il2Cpp.Field.Type> extends Il2CppPointer<T> {
        }
    }
}
export {};
