/// <reference types="frida-gum" />
import { NativeStruct } from "../../utils/native-struct";
/** Represent a parameter passed by reference. */
declare class Il2CppReference<T extends Il2Cpp.Field.Type> extends NativeStruct {
    readonly type: Il2Cpp.Type;
    constructor(handle: NativePointer, type: Il2Cpp.Type);
    /** Gets the element referenced by the current reference. */
    get value(): T;
    /** Sets the element referenced by the current reference. */
    set value(value: T);
    /** */
    toString(): string;
    static to<T extends number | NativePointer>(value: T, type: Il2Cpp.Type): Il2Cpp.Reference<T>;
    static to<T extends Exclude<Il2Cpp.Field.Type, number | NativePointer>>(value: T): Il2Cpp.Reference<T>;
}
declare global {
    namespace Il2Cpp {
        class Reference<T extends Il2Cpp.Field.Type = Il2Cpp.Field.Type> extends Il2CppReference<T> {
        }
    }
}
export {};
