import { NativeStruct } from "../../utils/native-struct";
/** Represents a `Il2CppThread`. */
declare class Il2CppThread extends NativeStruct {
    /** Gets the native id of the current thread. */
    get id(): number;
    /** Determines whether the current thread is the garbage collector finalizer one. */
    get isFinalizer(): boolean;
    /** Gets the encompassing object of the current thread. */
    get object(): Il2Cpp.Object;
    /** Detaches the thread from the application domain. */
    detach(): void;
    /** Schedules a callback on the current thread. */
    schedule<T>(block: () => T | Promise<T>, delayMs?: number): Promise<T>;
}
declare global {
    namespace Il2Cpp {
        class Thread extends Il2CppThread {
        }
    }
}
export {};
