/** Tracing utilities. */
declare class Il2CppTracer {
    #private;
    domain(): FilterAssemblies;
    assemblies(...assemblies: Il2Cpp.Assembly[]): FilterClasses;
    classes(...classes: Il2Cpp.Class[]): FilterMethods;
    methods(...methods: Il2Cpp.Method[]): FilterParameters;
    filterAssemblies(filter: (assembly: Il2Cpp.Assembly) => boolean): FilterClasses;
    filterClasses(filter: (klass: Il2Cpp.Class) => boolean): FilterMethods;
    filterMethods(filter: (method: Il2Cpp.Method) => boolean): FilterParameters;
    filterParameters(filter: (parameter: Il2Cpp.Parameter) => boolean): Pick<Il2Cpp.Tracer, "and">;
    and(): ReturnType<typeof Il2Cpp["trace"]> & Pick<Il2Cpp.Tracer, "attach">;
    attach(mode?: "full" | "detailed"): void;
}
type FilterAssemblies = FilterClasses & Pick<Il2Cpp.Tracer, "filterAssemblies">;
type FilterClasses = FilterMethods & Pick<Il2Cpp.Tracer, "filterClasses">;
type FilterMethods = FilterParameters & Pick<Il2Cpp.Tracer, "filterMethods">;
type FilterParameters = Pick<Il2Cpp.Tracer, "and"> & Pick<Il2Cpp.Tracer, "filterParameters">;
declare global {
    namespace Il2Cpp {
        class Tracer extends Il2CppTracer {
        }
    }
}
export {};
